//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://emule.sf.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

// DownloadListCtrl.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "DownloadListCtrl.h"
#include "otherfunctions.h"



// CDownloadListCtrl

IMPLEMENT_DYNAMIC(CDownloadListCtrl, CListBox)
CDownloadListCtrl::CDownloadListCtrl()
{
}

CDownloadListCtrl::~CDownloadListCtrl()
{
}

void CDownloadListCtrl::Init(){
	CImageList m_ImageList; //dummy list
	m_ImageList.Create(1, 17,ILC_COLOR, 1, 1); 
	SetImageList(&m_ImageList, LVSIL_SMALL);

	InsertColumn(0,"File Name",LVCFMT_LEFT,260);
	InsertColumn(1,"Size",LVCFMT_LEFT,60);
	InsertColumn(2,"Transfered",LVCFMT_LEFT,65);
	InsertColumn(3,"Speed",LVCFMT_LEFT,65);
	InsertColumn(4,"Progress",LVCFMT_LEFT,170);
	InsertColumn(5,"Sources",LVCFMT_LEFT,50);
	InsertColumn(6,"Priority",LVCFMT_LEFT,55);
}
void CDownloadListCtrl::AddFile(CPartFile* toadd){
	uint32 itemnr = GetItemCount();
	InsertItem(LVIF_PARAM,itemnr,0,0,0,0,(LPARAM)toadd);
}

void CDownloadListCtrl::UpdateItem(CPartFile* toupdate){
	LVFINDINFO find;
	find.flags = LVFI_PARAM;
	find.lParam = (LPARAM)toupdate;
	Update(FindItem(&find));
}

void CDownloadListCtrl::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct){
	if (!lpDrawItemStruct->itemData)
		return;
	CDC* dc = CDC::FromHandle(lpDrawItemStruct->hDC);
	
	COLORREF crOldTextColor = dc->GetTextColor();
	COLORREF crOldBkColor = dc->GetBkColor();
	RECT sel_rec;
	memcpy(&sel_rec,&lpDrawItemStruct->rcItem,sizeof(RECT));
	sel_rec.bottom--;
	sel_rec.top++;
	if ((lpDrawItemStruct->itemAction | ODA_SELECT) &&
		(lpDrawItemStruct->itemState & ODS_SELECTED)){
		dc->SetTextColor(::GetSysColor(COLOR_HIGHLIGHTTEXT));
		dc->SetBkColor(::GetSysColor(COLOR_HIGHLIGHT));
		dc->FillSolidRect(&sel_rec, 
			::GetSysColor(COLOR_HIGHLIGHT));
	}
	else
		dc->FillSolidRect(&sel_rec, crOldBkColor);

	
	CPartFile* partfile = (CPartFile*)lpDrawItemStruct->itemData;
	RECT cur_rec;
	memcpy(&cur_rec,&lpDrawItemStruct->rcItem,sizeof(RECT));

	char buffer[200];
	// file name
	this->GetColumnWidth(0);
	cur_rec.right = GetColumnWidth(0);
	cur_rec.left += 4;
	dc->DrawText(partfile->GetFileName(),strlen(partfile->GetFileName()),&cur_rec,DT_LEFT|DT_SINGLELINE|DT_VCENTER);
	//size
	cur_rec.left = cur_rec.right+4;
	cur_rec.right += GetColumnWidth(1);
	CastItoXBytes(partfile->GetFileSize(),buffer);
	dc->DrawText(buffer,strlen(buffer),&cur_rec,DT_LEFT|DT_SINGLELINE|DT_VCENTER);
	// transfered
	cur_rec.left = cur_rec.right+4;
	cur_rec.right += GetColumnWidth(2);
	CastItoXBytes(partfile->GetTransfered(),buffer);
	dc->DrawText(buffer,strlen(buffer),&cur_rec,DT_LEFT|DT_SINGLELINE|DT_VCENTER);	
	// speed
	cur_rec.left = cur_rec.right+4;
	cur_rec.right += GetColumnWidth(3);
	uint32 datarate = 0;
	sprintf(buffer,"%.1f KB/s",(float)datarate/1024);
	dc->DrawText(buffer,strlen(buffer),&cur_rec,DT_LEFT|DT_SINGLELINE|DT_VCENTER);
	
	// Progress
	cur_rec.left = cur_rec.right;
	cur_rec.right += GetColumnWidth(4);
	cur_rec.bottom--;
	cur_rec.top++;
	partfile->DrawStatusBar(dc,&cur_rec);
	cur_rec.bottom++;
	cur_rec.top--;
	//sources
	cur_rec.left = cur_rec.right+4;
	cur_rec.right += GetColumnWidth(5);
	uint32 sourcesav = 0;
	uint32 sourcesdown = 0;
	sprintf(buffer,"%i (%i)",sourcesav,sourcesdown);
	dc->DrawText(buffer,strlen(buffer),&cur_rec,DT_LEFT|DT_SINGLELINE|DT_VCENTER);
	//prio
	cur_rec.left = cur_rec.right+4;
	cur_rec.right += GetColumnWidth(5);
	switch(partfile->GetPriority()){
		case 0:
			dc->DrawText("Low",3,&cur_rec,DT_LEFT|DT_SINGLELINE|DT_VCENTER);
			break;
		case 1:
			dc->DrawText("Normal",6,&cur_rec,DT_LEFT|DT_SINGLELINE|DT_VCENTER);
			break;
		case 2:
			dc->DrawText("High",4,&cur_rec,DT_LEFT|DT_SINGLELINE|DT_VCENTER);
			break;
	}
   dc->SetTextColor(crOldTextColor);
   dc->SetBkColor(crOldBkColor);

}


BEGIN_MESSAGE_MAP(CDownloadListCtrl, CListCtrl)
END_MESSAGE_MAP()



// CDownloadListCtrl message handlers

