//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://emule.sf.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#pragma once
#include "knownfile.h"
#include "types.h"
#include "opcodes.h"

#define	PS_READY			0
#define PS_WAITINGFORHASH	2
#define PS_HASHING			3
#define PS_ERROR			4
#define	PS_EMPTY			5
#define	PS_UNKNOWN			6

class CPartFile : public CKnownFile {
public:
	CPartFile();
	virtual ~CPartFile();	
	bool	CreateFromFile(char* directory,char* filename)	{return false;}// not supported in this class
	bool	LoadFromFile(FILE* file)						{return false;}
	bool	WriteToFile(FILE* file)							{return false;}
	bool	IsPartFile()									{return true;}
	bool	LoadPartFile(char* directory, char* filename); //filename = *.part.met
	bool	SafePartFile();
	void	PartFileHashFinished(CKnownFile* result);
	void	AddGap(uint32 start, uint32 end);
	void	FillGap(uint32 start, uint32 end);
	bool	IsComplete(uint32 start, uint32 end);
	char*	GetPartMetFileName()							{return partmetfilename;}
	uint32	GetTransfered()									{return transfered;}
	uint8	GetPriority()									{return priority;}
	void	DrawStatusBar(CDC* dc,RECT* rect);
	uint8	GetStatus()										{return status;}
	void	WritePartStatus(CFile* file);
	char*	GetFullName()									{return fullname;}
private:
	char*	fullname;
	char*	partmetfilename;
	uint32	transfered;
	bool	paused;
	uint8	priority;
	uint8	status;
	bool	newdate;	// indicates if there was a writeaccess to the .part file
	CTypedPtrList<CPtrList, Gap_Struct*> gaplist;
};
