//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://emule.sf.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#pragma once

#include "types.h"
#include "otherstructs.h"
#include "listensocket.h"
#include "baseclient.h"

class CClientReqSocket;

class CUploadClient: public CBaseClient
{
public:
	CUploadClient(char* hellodata,uint16 size,CClientReqSocket* sender);
	~CUploadClient();
	uint32	GetScore();
	bool	IsDownloading()	{return upstarttime;}
	void	AddReqBlock(Requested_Block_Struct* reqblock);
	bool	CreateNextBlockPackage();
	void	SetUpStartTime(uint32 time = 0);
	void	SetWaitStartTime(uint32 time = 0);
	uint32	GetWaitStartTime()		{return starttime;}
	uint32	GetWaitTime()			{return upstarttime-starttime;}
	uchar	reqfileid[16];
	uint32	SendBlockData(uint32 maxammount);
	CMemFile*	cur_block;
private:
	uint32	starttime;
	uint32	upstarttime;
	int16	filepriority;
	char	userhash[16];
	CTypedPtrList<CPtrList, Requested_Block_Struct*> blockreqlist;
	CTypedPtrList<CPtrList, Requested_Block_Struct*> doneblocklist;
};